module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 3);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
exports.SIDE_MENU_ACTION_TYPES = {
    SET_ACTIVE: 'side-menu/SET_ACTIVE',
    SET_INACTIVE: 'side-menu/SET_INACTIVE',
    SET_INFO: 'side-menu/SET_INFO',
};
exports.RESIZE_ACTIONS_TYPES = {
    RESIZE: 'resize/RESIZE',
};
exports.CONSOLE_PANEL_TYPES = {
    SET_ACTIVE_TAB: 'console-panel/SET_ACTIVE_TAB',
    OPEN_CONSOLE_PANEL: 'console-panel/OPEN_CONSOLE_PANEL',
    CLOSE_CONSOLE_PANEL: 'console-panel/CLOSE_CONSOLE_PANEL',
    RESIZE_CONSOLE_PANEL: 'console-panel/RESIZE_CONSOLE_PANEL',
};
exports.EDITOR_TYPES = {
    CHANGE_EDITOR_NUMBERS: 'editor/CHANGE_EDITOR_NUMBERS',
    CHANGE_ACTIVE_EDITOR: 'editor/CHANGE_ACTIVE_EDITOR',
};


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
const resize_1 = __webpack_require__(2);
exports.setActiveSideMenu = iconId => (dispatch, getState) => {
    dispatch({
        type: actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_ACTIVE,
        payload: iconId,
    });
    const { resize: rsz } = getState();
    if (!rsz.treePanel) {
        const size = rsz.treePanelPrev || 300;
        dispatch(resize_1.resize('treePanel', size));
    }
};
exports.setInactiveSideMenu = () => (dispatch, getState) => {
    dispatch({ type: actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_INACTIVE });
    dispatch(resize_1.resizeTreePanel(0));
};
exports.setTabInfo = (tabName, message) => ({
    type: actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_INFO,
    payload: { tabName, message },
});


/***/ }),
/* 2 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
const sideMenu_1 = __webpack_require__(1);
exports.resize = (key, value) => ({
    type: actionTypes_1.RESIZE_ACTIONS_TYPES.RESIZE,
    key,
    value,
});
exports.resizeTreePanel = width => (dispatch, getState) => {
    const state = getState();
    dispatch(exports.resize('treePanel', width));
    if (!state.sideMenu.active && width) {
        dispatch(sideMenu_1.setActiveSideMenu(state.sideMenu.activePrev));
    }
    else if (state.sideMenu.active && !width) {
        dispatch(sideMenu_1.setInactiveSideMenu());
    }
};


/***/ }),
/* 3 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(4));
__export(__webpack_require__(9));


/***/ }),
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var sideMenu_1 = __webpack_require__(5);
exports.sideMenuReducer = sideMenu_1.default;
var resize_1 = __webpack_require__(6);
exports.resizeReducer = resize_1.default;
var consolePanel_1 = __webpack_require__(7);
exports.consolePanelReducer = consolePanel_1.default;
var editors_1 = __webpack_require__(8);
exports.editorsReducer = editors_1.default;


/***/ }),
/* 5 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
const reducer = (state = { active: null, activePrev: null, info: {} }, action) => {
    const { type, payload } = action;
    switch (type) {
        case actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_ACTIVE:
            return Object.assign({}, state, { active: payload });
        case actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_INACTIVE:
            return Object.assign({}, state, { active: null, activePrev: state.active });
        case actionTypes_1.SIDE_MENU_ACTION_TYPES.SET_INFO:
            return Object.assign({}, state, { info: Object.assign({}, state.info, { [payload.tabName]: payload.message }) });
        default:
            return state;
    }
};
exports.default = reducer;


/***/ }),
/* 6 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
exports.default = (state = {}, action) => {
    const { type } = action;
    return type === actionTypes_1.RESIZE_ACTIONS_TYPES.RESIZE
        ? Object.assign({}, state, { [action.key]: action.value }) : state;
};


/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
const options = [
    {
        label: 'Problems',
        value: 'problems',
    },
    {
        label: 'Output',
        value: 'output',
    },
    {
        label: 'Debug console',
        value: 'debug',
    },
    {
        label: 'Terminal',
        value: 'terminal',
    },
];
const reducer = (state = { options, resize: false }, action) => {
    const { payload, type } = action;
    switch (type) {
        case actionTypes_1.CONSOLE_PANEL_TYPES.SET_ACTIVE_TAB:
            return Object.assign({}, state, { active: payload });
        case actionTypes_1.CONSOLE_PANEL_TYPES.OPEN_CONSOLE_PANEL:
            return Object.assign({}, state, { active: 'terminal' });
        case actionTypes_1.CONSOLE_PANEL_TYPES.CLOSE_CONSOLE_PANEL:
            return Object.assign({}, state, { active: null });
        case actionTypes_1.CONSOLE_PANEL_TYPES.RESIZE_CONSOLE_PANEL:
            return Object.assign({}, state, { resize: !state.resize });
        default:
            return state;
    }
};
exports.default = reducer;


/***/ }),
/* 8 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
const initialState = {
    activeEditor: 1,
    editorsCount: 1,
};
exports.default = (state = initialState, action) => {
    const { type, payload } = action;
    switch (type) {
        case actionTypes_1.EDITOR_TYPES.CHANGE_EDITOR_NUMBERS:
            let editorsCount = state.editorsCount;
            if (action.increase && state.editorsCount < 2) {
                editorsCount = state.editorsCount + 1;
            }
            else if (!action.increase && state.editorsCount > 1) {
                editorsCount = state.editorsCount - 1;
            }
            return Object.assign({}, state, { editorsCount });
        case actionTypes_1.EDITOR_TYPES.CHANGE_ACTIVE_EDITOR:
            return Object.assign({}, state, { activeEditor: action.index <= 2 ? action.index : state.activeEditor });
        default:
            return state;
    }
};


/***/ }),
/* 9 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

function __export(m) {
    for (var p in m) if (!exports.hasOwnProperty(p)) exports[p] = m[p];
}
Object.defineProperty(exports, "__esModule", { value: true });
__export(__webpack_require__(1));
__export(__webpack_require__(2));
__export(__webpack_require__(10));
__export(__webpack_require__(11));


/***/ }),
/* 10 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
exports.setActiveConsoleTab = (tab) => ({
    type: actionTypes_1.CONSOLE_PANEL_TYPES.SET_ACTIVE_TAB,
    payload: tab,
});
exports.openConsolePanel = () => ({
    type: actionTypes_1.CONSOLE_PANEL_TYPES.OPEN_CONSOLE_PANEL,
});
exports.closeConsolePanel = () => ({
    type: actionTypes_1.CONSOLE_PANEL_TYPES.CLOSE_CONSOLE_PANEL,
});
exports.resizeConsolePanel = () => ({
    type: actionTypes_1.CONSOLE_PANEL_TYPES.RESIZE_CONSOLE_PANEL,
});


/***/ }),
/* 11 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
const actionTypes_1 = __webpack_require__(0);
exports.changeEditorsNumber = (increase) => ({
    type: actionTypes_1.EDITOR_TYPES.CHANGE_EDITOR_NUMBERS,
    increase,
});
exports.changeActiveEditor = (index) => ({
    type: actionTypes_1.EDITOR_TYPES.CHANGE_ACTIVE_EDITOR,
    index,
});


/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map